
function  xfit = STFfitting(Y2x,Model,Parameter)
% linear measurement model -fitting; the sensor data is converted into the
% state (position) space and then carry out fitting

St =1;
xfit(:,1) = Y2x([1,2],1);
xfit(:,2) = Y2x([1,2],2)*2-Y2x([1,2],1);

for i = 3:size(Y2x,2)
    if i <= Parameter.Band
        flag =ceil(i/2);
    end
    if i-St >= Parameter.Band
        St = i - Parameter.Band;
        flag = i- floor(Parameter.Band/2);
    end
        xout = Y2x([1,2],St:i);
        T = St:i;
        [p1]= polyfit(T, xout(1,:), Parameter.FitOrder);
        [p2]= polyfit(T, xout(2,:), Parameter.FitOrder);    
    switch Model 
        case 'smoothing'
            [xfit(1,flag:i)] = polyval(p1,flag:i);
            [xfit(2,flag:i)] = polyval(p2,flag:i); 
        case 'filtering'
            [xfit(1,i)] = polyval(p1,i);
            [xfit(2,i)] = polyval(p2,i);
        case 'forecasting'
%             Parameter.Band = 50;
            [xfit(1,i+Parameter.predictStep)] = polyval(p1,i+Parameter.predictStep);
            [xfit(2,i+Parameter.predictStep)] = polyval(p2,i+Parameter.predictStep);
        otherwise
            disp('Please choose a correct fitting model from smoothing, filtering and forecasting')
    end
end
