
function  xfit = nlinSTFfitting(Y,H_fun,Model,Parameter)

p = [0.1, 0, 0, 0.1]; % m=2, two dimensions
% p = [0.01, 0.1, 0.5,  0.01,0.1, 0.15]; % m=3, two dimensions

St =1; options=optimset('Display','off');
% Parameter.initial warms up the first two steps of the fitting,
xfit(:,1) = Parameter.initial([1,2],:); % for fair, we also set a good start point for fitting as did with all filters/smoother
xfit(:,2) = [Parameter.initial(1,1)+Parameter.initial(3,1);Parameter.initial(2,1)+Parameter.initial(4,1)];
for i = 3:size(Y,2)     
    if i <= Parameter.Band
        flag =ceil(i/2);
    end
    if i-St >= Parameter.Band
        St = i - Parameter.Band;
        flag = i- floor(Parameter.Band/2);
    end
        T = St:i;        
        [p,resnorm] = lsqcurvefit(H_fun,p,T,Y(:,St:i),[],[],options);
        % resnorm may be used for some ad-hoc monitor and decision
        p1 = p([2,1]);
        p2 = p([4,3]);
%         p1 = p([3,2,1]);
%         p2 = p([6,5,4]);
    switch Model 
        case 'smoothing'
            [xfit(1,flag:i)] = polyval(p1,flag:i);
            [xfit(2,flag:i)] = polyval(p2,flag:i); 
        case 'filtering'
            [xfit(1,i)] = polyval(p1,i);
            [xfit(2,i)] = polyval(p2,i);
        case 'forecasting'
%             Parameter.Band = 50;
            [xfit(1,i+Parameter.predictStep)] = polyval(p1,i+Parameter.predictStep);
            [xfit(2,i+Parameter.predictStep)] = polyval(p2,i+Parameter.predictStep);
        otherwise
            disp('Please choose a correct fitting model from smoothing, filtering and forecasting')
    end
end
