
function  xfit = nlinSTFfitting_sin(Y,H_fun,Model,Parameter)


p = [3, 3, 0.03, 3, 0, 2];
% p = [0.01, 0.1, 0.5,  0.01,0.1, 0.15];

St =1; options=optimset('Display','off');
xfit(:,1) = Parameter.initial([1,2],:); % for fair, we also set a good start point for fitting as did with all filters/smoother
xfit(:,2) = [Parameter.initial(1,1)+Parameter.initial(3,1);Parameter.initial(2,1)+Parameter.initial(4,1)];
for i = 3:size(Y,2)     
    if i <= Parameter.Band
        flag =ceil(i/2);
    end
    if i-St >= Parameter.Band
        St = i - Parameter.Band;
        flag = i- floor(Parameter.Band/2);
    end
        T = St:i;        
        [p,resnorm] = lsqcurvefit(H_fun,p,T,Y(:,St:i),[],[],options);
        % resnorm may be used for some ad-hoc monitor and decision
    switch Model 
        case 'smoothing'
            d = flag:i;
            [xfit(1,d)] = p(1)+p(2)*cos(p(3)*d+p(4));
            [xfit(2,d)] = p(5)+p(6)*sin(p(3)*d+p(4)); 
        case 'filtering'
            [xfit(1,i)] = p(1)+p(2)*cos(p(3)*i+p(4));
            [xfit(2,i)] = p(5)+p(6)*sin(p(3)*i+p(4));
        case 'forecasting'
%             Parameter.Band = 50;
            [xfit(1,i+Parameter.predictStep)] = p(1)+p(2)*cos(p(3)*(i+Parameter.predictStep)+p(4));
            [xfit(2,i+Parameter.predictStep)] = p(5)+p(6)*sin(p(3)*(i+Parameter.predictStep)+p(4));
        otherwise
            disp('Please choose a correct fitting model from smoothing, filtering and forecasting')
    end
end
